=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: ros-noetic-taskflow
 Section: misc
 Priority: optional
-Maintainer: user <user@todo.todo>
+Maintainer: Levi Armstrong <levi.armstrong@swri.org>
 Build-Depends: debhelper (>= 9.0.0), cmake
-Homepage: 
+Homepage: https://taskflow.github.io
 Standards-Version: 3.9.2
 
 Package: ros-noetic-taskflow
